program Double_List_QuickSort;
uses crt;
type rodykle = ^dalys;
     dalys = record
     pavadinimas : string[20];
     gamintojas : string[20];
     modelis : string[20];
     regnr : string[20];
     kaina : string[20];
     next : rodykle;
     prev : rodykle;
     end;
var                n: integer;
list_head, list_tail: rodykle;

function jump_to_elem(galva:rodykle; pointer:integer):string;
var t: rodykle;
    u: integer;
begin
  t:=galva;
  pointer:=pointer - 1;
  for u:=1 to pointer do t:=t^.next;
  jump_to_elem:=t^.pavadinimas;
end;

function list_length(galva: rodykle):integer;
var h: rodykle;
    i: integer;
begin
  i:=0;
  h:= galva;
  while h<>nil do
  begin
    i:=i+1;
    h:=h^.next;
  end;
  list_length:=i;
end;

procedure sukeisti(var galva: rodykle; s,t: integer);
var i :integer;
d1,d2: string;
        w,e: rodykle;
begin
  w:=galva;
  e:=galva;
  for i:=1 to s-1 do w:=w^.next; d1:= w^.pavadinimas;
  for i:=1 to t-1 do e:=e^.next; d2:= e^.pavadinimas;
  w^.pavadinimas:= d2;
  e^.pavadinimas:= d1;
end;

function partition(var galva:rodykle; L,R: integer): integer;
var i,j: integer;
    pivot : string;
            h: rodykle;
begin
  h:=galva;
  pivot := jump_to_elem(h,R);
  i:= L-1;
  j:= R+1;
  repeat
    repeat
      i:=i+1;
    until pivot <= jump_to_elem(h,i);
    repeat
      j := j-1;
    until pivot >= jump_to_elem(h,j);
    sukeisti(galva,i,j);
  until j <= i;
  sukeisti(galva,i,j);
  partition := i;
end;
              
procedure Quicksort (var galva:rodykle; L,R: integer);
var m: integer; 
begin
  if L < R then
  begin
    m := partition(galva,L,R);
    Quicksort(galva,L,m-1);
    Quicksort(galva,m,R);
  end
end;

procedure skaityti (var pradzia,pabaiga : rodykle; var kiek_sarasu : integer);
     var rasta : integer;
         failas : text;
         //simbolis : char;
         eilute : string;
         ilgis : integer;
         i : integer;
         elem: rodykle;
       begin
         kiek_sarasu:=0;
         Assign (failas,'duomenys.txt'); Reset (failas);
         while not EOF (failas) do
         begin
           new(elem);
           elem^.pavadinimas := '';
           elem^.gamintojas := '';
           elem^.modelis := '';
           elem^.regnr := '';
           elem^.kaina := '';
           rasta := 0;
           ReadLn (failas, eilute);
           ilgis := Length (eilute);
           for i := 1 to ilgis do
           begin
             if eilute [i] = ';' then rasta := rasta +1;
             if rasta = 0 then
               begin
                 if eilute[i] <> ';' then elem^.pavadinimas := elem^.pavadinimas + eilute[i];
               end;
             if rasta = 1 then
               begin
                 if eilute [i] <> ';' then elem^.gamintojas := elem^.gamintojas + eilute[i];
               end;
             if rasta = 2 then
               begin
             if eilute [i] <> ';' then elem^.modelis := elem^.modelis + eilute[i];
               end;
             if rasta = 3 then
               begin
            if eilute [i] <> ';' then elem^.regnr := elem^.regnr + eilute[i];
               end;
             if rasta = 4 then
               begin
             if eilute [i] <> ';' then elem^.kaina := elem^.kaina + eilute[i];
               end;
           end;
           kiek_sarasu := kiek_sarasu+1;
            if pradzia = nil then
              begin
                pradzia := elem;
                pabaiga := elem;
                pradzia^.prev := nil;
                pabaiga^.next := nil;
              end
            else
              begin
                pabaiga^.next := elem;
                elem^.prev:=pabaiga;
                pabaiga:=elem;
                pabaiga^.next :=nil;
              end;
            end;
            writeln('sarasu sk: ', kiek_sarasu);
           Close (failas);
       end;

procedure print(galva: rodykle);
var h: rodykle;
begin
  h:= galva;
  while h<>nil do begin
    writeln(h^.pavadinimas);
    h:=h^.next;
  end;
  writeln;
end;


begin
  list_head:=nil;
  list_tail:=nil;
  skaityti(list_head, list_tail, n);
  writeln('Ivesti duomenys:');
  print(list_head);
  Quicksort(list_head,1,list_length(list_head));
  writeln('Surusiuoti duomenys:');
  print(list_head);
  writeln('Saraso ilgis:  ', list_length(list_head));
  writeln;
  readln;
end.
